 
#include <sys/types.h> 
#include <sys/socket.h> 
#include <netinet/in.h> 
#include <netdb.h> 
#include <stdio.h> 
#include <errno.h> 
#include "risposta.h" 
#include "inviatcp.h" 
#include "log.h"



 
int servertcp(const char *server_port) 
{ 
  int details;
  char *codhttp;
  long int lunghezza;
  int sock, sockmsg;  
  struct sockaddr_in server; 
  int nfigli=0; 
  char *daspedire;

  if( (sock = socket(AF_INET,SOCK_STREAM,0)) <0 )  
    { 
      printf("server: errore %s nella creazione della socket\n", strerror(errno)); 
      exit(1); 
    } 
  
  server.sin_family = AF_INET; 
  server.sin_addr.s_addr = INADDR_ANY; 
  server.sin_port = htons(atoi(server_port)); 
   
  if(bind(sock, (struct sockaddr *)&server, sizeof(server)))  
    { 
      printf("server: bind fallita\n"); 
      exit(1); 
    } 
   
  printf("server: rispondo sulla porta %d\n", ntohs(server.sin_port)); 
   
  if(listen(sock, MAX_CODA)<0)  
    { 
      printf("server: errore %s nella listen\n", strerror(errno)); 
      exit(1); 
    } 
   
  while(1) 
    {   
      char msg[MAX_MSG_LEN]; 
      char *msgfiltrato;int trovato=0,ct=0; 
      nfigli++; 
        printf("\n\n\n\n SERVER TCP: MAIN CYCLE\n"); 
      if((sockmsg=accept(sock,0,0))<0)  
	{ 
	  printf("server: errore %s nella accept\n", strerror(errno)); 
	  exit(1); 
	} 
     
      if(fork()==0)  
	{ 
	  int totale=0; unsigned int fromlen; 
	  int bytes; 
	  struct sockaddr_in from; 
	  char *daspedire; 
	   
	  close(sock);    
	  printf("figlio %d: mi occupo di una nuova connessione\n",nfigli); 
       
	  if (totale=recvfrom(sockmsg, msg,MAX_MSG_LEN,0,(struct sockaddr *)&from,&fromlen)<1 ) 
	    { 
	      perror("err read\n");exit(0); 
	    } 
	  printf(" Superata !!!! \n"); 
 
 
	   
	  while (!trovato&&(ct<=MAX_MSG_LEN)) 
	    { 
	      ct++; 
	      /*    printf(" msg[%d]=%c ",ct,msg[ct]);*/ 
	      if ((ct+3<=MAX_MSG_LEN)&&(msg[ct]=='\r')&&(msg[ct+1]=='\n')&&(msg[ct+2]=='\r')&&(msg[ct+3]=='\n')) 
		{ 
		  trovato=1; 
		}  
	    } 
	   
	  if (!trovato) {printf("\n servertcp.c: pacchetto senza stringa terminale "); exit(0);} 
	  msgfiltrato= (char*)calloc(ct+5,sizeof(char)); 
	  strncpy(msgfiltrato,msg,ct+3); 
	  msgfiltrato[ct+4]='\0'; 
  
	  printf("\naaaaaa\nmessaggio \n%s\n",msg);
  
	    printf("lette %d bytes figlio %d:\n arrivato il msg:\n %s\n \nfromlen=%d \nind=0x%.8x \n",totale, nfigli, msgfiltrato,fromlen,ntohs(from.sin_addr.s_addr));   
	  printf("figlio %d: PRIMA di analizza_rich\n"); 
	    



	  /***************
qui bisogna implementare la richiesta successiva dei pezzi di body di
pacchetto **********/



	  details=RCLOSED;
	  
	  
	  do
	    {
	      
	      printf("\n SERVERTCP: details=%d",details);
	      
	      if ((daspedire=analizza_richiesta(msgfiltrato,&details,&lunghezza,codhttp))!=NULL)  
		{  
		  
		  int i; 
		  
		  
		  printf(" invio dovrei mandare %d bytes ",lunghezza); 
		  if (bytes=send(sockmsg,  (const char*) daspedire, lunghezza, 0)>0) 
		    { 
		      printf("\n inviati %d bytes",bytes); 
		      
		      /*se ho spedito qualcosa ed ho finito (details=RCLOSED)*/
		      /*aggiungo la transizione al log*/
		         printf("\n*******************prima di scrivi log");  
	     
		      /* ANDO LO PIJO L'IP????????????? e il codice http*/ 
/* 		       scrivilog(creaaccesslog("199.199.199.199",msgfiltrato,200,lunghezza));  */
		
			 
		{
char tt[16];char *temp;

strcpy(tt,"199.199.199.199");




temp=  creaaccesslog(tt,msgfiltrato,codhttp,lunghezza);  
       printf("\n*******************prima di scrivi log");  
printf("\nservertcp riga log=%s\n",temp);	 
  scrivilog(temp) ;




       printf("\n*******************dopo di scrivi log");  
		}

			 









      
		    }else    printf("\n problemi in send in servertcp: %d bytes",bytes);
		  
		  
		  
		  

		  free(daspedire);
		  
		} else   printf("\n problemi con analizza_richiesta");
	      printf("\n SERVERTCP: details=%d",details);
 
	      
	    } while (details==ROPEN);//repeat
	  
	  
	  printf("figlio %d: chiudo il sock temporaneo\n",nfigli); 
	  
	  close(sockmsg); 
	  printf("figlio %d: chiudo la connessione e esco\n", nfigli); 
	  exit(0); 
	}/* fine figlio */  
      else close(sockmsg); 
    }        
  close(sock); 
  printf("server: ho chiuso la prima socket\n"); 
  return 0; 
   
}  
 
int main(int argc,char** argv) 
{ 




     if(argc!=2)  
    { 
    printf("uso: %s <numero-della-porta>\n", argv[0]); 
    exit(1); 
    }


  servertcp(argv[1]); 
} 
 
 
 
 
 
