
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include "inviaudp.h"
#include "risposta.h"
#include "log.h"

int serverudp(const char *server_port)
{ 
  int details;long lunghezza;
  int sockid,nread,trovato=0,ct=0,bytes=0; unsigned int addrlen;
  struct sockaddr_in myaddr, clientaddr;char *daspedire,*msgfiltrato;
  char *codhttp;
  char msg[MAX_MSG_LEN];int i;
  for (i=0;i<MAX_MSG_LEN;i++) msg[i]=' ';
  printf("\nserver: creat sock port=%s that's %d\n",server_port,atoi(server_port));
  if ((sockid=socket(AF_INET,SOCK_DGRAM,0))<0)
    {printf("\nserver: socket error %d",errno);exit(0);}
  printf("\n server: binding");
  
  bzero((char*)&myaddr,sizeof(myaddr));
  printf("\n server: binding2");
  
  myaddr.sin_family=AF_INET;
  myaddr.sin_addr.s_addr=htonl(INADDR_ANY);
  myaddr.sin_port=htons(atoi(server_port));
  
  printf("\n server: bindin3g");
  printf("\n server:server port=%d",  ntohs(myaddr.sin_port));
  
  if ((bind(sockid,(struct sockaddr *)&myaddr,sizeof(myaddr))<0))
    {printf("\n server: error bind failed %d",errno); exit(0);}
  


  while(1)
    {
      
	  
	  char *pacchetto;
	  printf("\n\n\n START\n\n\n");
	  nread=recvfrom(sockid,msg, MAX_MSG_LEN,0,(struct sockaddr *)&clientaddr,&addrlen);
	  printf("\n server: serv ret code %d clientaddr.name=%x clientaddr.port=%d IO SONO nome=%x porta=%d",nread,ntohl(clientaddr.sin_addr.s_addr),ntohs(clientaddr.sin_port),ntohl(myaddr.sin_addr.s_addr),ntohs(myaddr.sin_port));
	  if (nread>0) printf("\n server: serv msg is {%s}",msg);
	  else  {printf("\n received NOTHING... nread=%d",nread);/*continue;*/ exit(0);}
	if ((nread>0)&&!fork())
	  { 
	    
	  
	  
	  
	  
	  
	  ct=0;/******/
	  trovato=0;
	  while (!trovato&&(ct<=nread))
	    {
	      ct++;
	      /*printf(" msg[%d]=%c ",ct,msg[ct]);*/
	      if ((ct+3<=MAX_MSG_LEN)&&(msg[ct]=='\r')&&(msg[ct+1]=='\n')&&(msg[ct+2]=='\r')&&(msg[ct+3]=='\n'))
		{
		  trovato=1;
		} 
	    }
	  
	  if (!trovato) {printf("\n serverudp.c: pacchetto senza stringa terminale "); exit(0); /*continue;*/}
    
	  msgfiltrato= (char*)calloc(ct+5,sizeof(char));
	  strncpy(msgfiltrato,msg,ct+3);
	  msgfiltrato[ct+4]='\0';
	  
	  
	  /*secondo parametro sempre settato a RCLOSED perche' vogliamo sempre e solo un pacchetto di risposta*/
	  details=RCLOSED;
	  
	  printf("\nserverudp.c :prima di daspedire lungh=%d",lunghezza);
	  if ((daspedire=analizza_richiesta(msgfiltrato,&details,&lunghezza,codhttp))!=NULL) 
	    { 
	      int i;
	      printf("\n serverudp invio dovrei mandare %d bytes msg=\n%s",lunghezza,daspedire);
	      printf("\ndopo daspedirelungh=%d",lunghezza);
	      printf("\n server: prima di SENDTO clientaddr.name=%x clientaddr.port=%d IO SONO nome=%x porta=%d",ntohl(clientaddr.sin_addr.s_addr),ntohs(clientaddr.sin_port),ntohl(myaddr.sin_addr.s_addr),ntohs(myaddr.sin_port));
	      
	      printf("\ndopo send lungh=%d",lunghezza);
	      bytes=sendto(sockid,  (char*) daspedire, lunghezza, 0,(struct sockaddr *)&clientaddr,sizeof(struct sockaddr));
	        printf("\n*******************prima di access log");  
	      /*ho spedito il pacchetto ... posso aggiornare il log*/
		{
char tt[16];char *temp;

strcpy(tt,"199.199.199.199");




temp=  creaaccesslog(tt,msgfiltrato,codhttp,lunghezza);  
       printf("\n*******************prima di scrivi log");  
printf("\nserverudp riga log=%s\n",temp);	 
  scrivilog(temp) ;




       printf("\n*******************dopo di scrivi log");  
		}
	      

	      /*deallochiamo la memoria usata per trasferire i pacchetti fra le varie funzioni */
	      printf("\ndealloco la memoria");
    printf("\n*************msgfiltr=%s",msgfiltrato);

	      free(msgfiltrato);
	      free(daspedire);
	      free(codhttp);
	      printf("\ndeallocata!!");
	      if (bytes>0)
		{
		  printf("\n inviati %d bytes sock=%d",bytes,sockid);
		}else    printf("\n problemi in send in serverudp: %d bytes",bytes);
	    } else   printf("\n problemi con analizza_richiesta");
	  
	  
	  
	  
	  
	  
	 close(sockid); 
	}
      /*close(sockid);*/
    }//while 1
  
}//serverudp
  main(int argc,char** argv)
    {

   
  /*controllo sul mumero di parametri...*/
  if(argc!=2)  
    { 
      printf("uso: %s <numero-della-porta>\n", argv[0]); 
      exit(1); 
    }

  serverudp(argv[1]);
}









